using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.TransferOut.Cqrs;

public record DeleteTransferOutItemCommand(string Id) : IRequest<bool>;

public class DeleteTransferOutItemHandler : IRequestHandler<DeleteTransferOutItemCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteTransferOutItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteTransferOutItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.InventoryTransaction.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}